/*********************************************
Project :keypad 
Version : 
Date    : 2007/02/21
Author  : AMIR_kit                            
Company :                                 
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 16.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512 
                              
                                                          R1
                COLUMN.1 PORTC.5 -------------------------------|~~~~~---o+5V
                                                                |
                                                     R2         |
                COLUMN.2 PORTC.6 ------------------~~~~~-o+5V   |
                                                  |             |
                                      R3          |             |
                COLUMN.3 PORTC.7-----~~~~~-o+5V   |             |
                                    |             |             |
                                    |             |             |                                   
                  ROW.1 PORTC.0 ----1-------------2-------------3
                                    |             |             |   
                  ROW.2 PORTC.1 ----4-------------5-------------6
                                    |             |             |           
                  ROW.3 PORTC.2 ----7-------------8-------------9
                                    |             |             |  
                  ROW.4 PORTC.3---start-----------0------------stop
  

 
*********************************************/

#include <mega16.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18
#endasm
#include <lcd.h>
#include <delay.h>
// Declare your global variables here

void main(void)
{
PORTA=0x00;
DDRA=0x00;
PORTB=0x00;
DDRB=0x00;
//PORT C FOR KEYPAD
DDRC.0=1;//ROW 1
PORTC.0=1;
DDRC.1=1;//ROW 2
PORTC.1=1;
DDRC.2=1;//ROW 3
PORTC.2=1;
DDRC.3=1;//ROW 4
PORTC.3=1;
DDRC.4=1;//+Vcc for Keypad
PORTC.4=1;
DDRC.5=0;//COLUMN 1
DDRC.6=0;//COLUMN 2
DDRC.7=0;//COLUMN 3
PORTD=0x00;
DDRD=0x00;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;
GICR|=0x00;
MCUCR=0x00;
MCUCSR=0x00;
TIMSK=0x00;
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

while (1)
      {       
      PORTC.0=0;// ROW.1=0
      PORTC.3=1;
      delay_ms(70);
      if(PINC.5==0)
      {
      lcd_clear();
      delay_ms(40);      
      if(PINC.5==0)
      {
      lcd_putchar('1');  
      }
      }
      delay_ms(40);
      if(PINC.6==0)
      {
      lcd_clear();
      delay_ms(40);      
      if(PINC.6==0)
      lcd_putchar('2');  
      }
      delay_ms(40);
      if(PINC.7==0)
      {
      lcd_clear();
      delay_ms(40);      
      if(PINC.7==0)
      lcd_putchar('3');  
      }       
      PORTC.1=0;// ROW.2=0
      PORTC.0=1;
      delay_ms(40);
      if(PINC.5==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.5==0)
      lcd_putchar('4');  
      }
      delay_ms(50);
      if(PINC.6==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.6==0)
      lcd_putchar('5');  
      }
      delay_ms(50);
      if(PINC.7==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.7==0)
      lcd_putchar('6');  
      }
      PORTC.2=0;// ROW.3=0
      PORTC.1=1;
      delay_ms(50);
      if(PINC.5==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.5==0)
      lcd_putchar('7');  
      }
      delay_ms(50);
      if(PINC.6==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.6==0)
      lcd_putchar('8');  
      }
      delay_ms(50);
      if(PINC.7==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.7==0)
      lcd_putchar('9');  
      }
      PORTC.3=0;// ROW.4=0
      PORTC.2=1;
      delay_ms(50);
      if(PINC.5==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.5==0)
      lcd_putsf("start");  
      }
      delay_ms(50);
      if(PINC.6==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.6==0)
      lcd_putsf("0");   
      }
      delay_ms(50);
      if(PINC.7==0)
      {
      lcd_clear();
      delay_ms(50);      
      if(PINC.7==0)
      lcd_putsf("stop");  
      }
      };
}
